/*******************************************************************************

  Intel SmartPHY DSL PCIe TC driver
         Copyright (c) 2020, MaxLinear, Inc.
         Copyright 2016 - 2020 Intel Corporation
         Copyright 2015 - 2016 Lantiq Beteiligungs-GmbH & Co. KG
         Copyright 2009 - 2014 Lantiq Deutschland GmbH
         Copyright 2007 - 2008 Infineon Technologies AG

  For licensing information, see the file 'LICENSE' in the root folder of
  this software module.

*******************************************************************************/

#ifndef __DFE_H__
#define __DFE_H__

#define MEI_OFFSET		0x2C0000
#define DSL_OFFSET		0x2D0000
#define MEIAD(a)		((a)+MEI_OFFSET)

/* Dsp Mgmt Address Constants */
#define DSP_MGMT_BASE		(0x0000)
#define DSP_MGMT_REG(r)		(DSP_MGMT_BASE + (r))
#define ME_ARC2ME_STAT		DSP_MGMT_REG(0x0004)
#define ME_DBG_RD_AD		DSP_MGMT_REG(0x002C)
#define ME_DBG_WR_AD		DSP_MGMT_REG(0x0030)
#define ME_DBG_DATA		DSP_MGMT_REG(0x0034)


struct me_cfg_def {
	u32 addr;
	u32 data;
	u32 type;
};

/* Header file to set the Loopback rate to programmable! */
#include "prograte.h"

#endif /* __DFE_H__ */
